#include <stdio.h>
#include "promile-qt.h"
#define MAXPATH 1000

extern float dopuszczalna[];
extern float pierwszy;
using namespace Ui;
extern char plec;
FILE * plik;
int pr_cz_wi; //wielko czcionki programu
QFont czcionka_programu;
QFont czcionka_wynikow;
char * kat_domowy;
char sciezka[MAXPATH];

char *  katalog_domowy_plik(char * plik)
{	
	kat_domowy = getenv("HOME");
	strcpy (sciezka,kat_domowy);
	strcat (sciezka,"/");
	strcat (sciezka,plik);
	return sciezka;
}

void Form1::czytaj_konfiguracje()
{	char nazwa[20];
	char wartosc[20];
	char wersja[20];
	char * endptr;
	//domyslne
	czcionka_programu.setPointSize(10);
	czcionka_wynikow.setPointSize(12);
	//
#ifdef WIN32
	plik = fopen("promileqt.rc","r");
#else
	strcpy(sciezka,katalog_domowy_plik(".promileqt.rc"));
	plik = fopen(sciezka,"r");
#endif

	if (!plik)
	{
		printf("%s","Bd odczytu pliku");
	}
	else
	{
		fscanf(plik,"%s%*s%s\n",nazwa,wersja); //Wersja
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); //Pe
		if (strcmp(wartosc,"k")==0) {ui.radioButton_k->setChecked(true);}
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Waga
		ui.spinBox_waga->setValue((int)strtof(wartosc,&endptr));
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Wzrost
		ui.spinBox_wzrost->setValue((int)strtof(wartosc,&endptr));
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Usuwanie alkoholu stale
		ui.doubleSpinBox_prom_na_godz->setValue(strtof(wartosc,&endptr));
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // kraj
		ui.comboBox_kraj->setCurrentIndex((int) strtof(wartosc,&endptr));
		ui.doubleSpinBox_dop_stez->setValue(dopuszczalna[ui.comboBox_kraj->currentIndex()]);
		if (ui.comboBox_kraj->currentIndex()!=0) {ui.doubleSpinBox_dop_stez->setEnabled(false);}
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // smierc
		ui.doubleSpinBox_dawka_smiertelna->setValue(strtof(wartosc,&endptr));
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // objetosc
		ui.spinBox_ilosc->setValue((int)strtof(wartosc,&endptr));
		if ((int)strtof(wartosc,&endptr)<=50)
		{
			ui.spinBox_dl_pic->setValue(1);
		}
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Zawartosc alkoholu
		ui.doubleSpinBox_zawartosc->setValue(strtof(wartosc,&endptr));
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // wielkosc czcionki programu
		czcionka_programu.setPointSize((int)strtof(wartosc,&endptr));
		ui.spinBox_cz_pr_wi->setValue((int)strtof(wartosc,&endptr));
		ustaw_czcionke_programu(czcionka_programu);
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // wielkosc czcionki wynikow
		czcionka_wynikow.setPointSize((int)strtof(wartosc,&endptr));
		ui.spinBox_cz_wy_wi->setValue((int)strtof(wartosc,&endptr));
		ustaw_czcionke_wynikow(czcionka_wynikow);
		fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Co ile minut wynik
		ui.spinBox_co_ile->setValue((int)strtof(wartosc,&endptr));
		
		if (strcmp(wartosc,"0.6.1.1")==1)
		{
			fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Usuwanie alkoholu zmienne
			ui.doubleSpinBox_maxg_na_godz->setValue(strtof(wartosc,&endptr));
			fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Model usuwania
			if (strcmp(wartosc,"zmienny")==0)
			{
				(ui.radioButton_zmienna_szybkosc->setChecked(true));
			}
		}
		if (strcmp(wartosc,"0.7.1")==1)
		{
			fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Pocztek imprezy
			pierwszy=strtof(wartosc,&endptr);
			ustaw_czas_rozpoczecia((int) pierwszy);
			ustaw_czas_zakonczenia(int (pierwszy+240));
			fscanf(plik,"%s%*s%s\n",nazwa,wartosc); //CZy uwzgledniac BMI
			if (strcmp(wartosc,"t")==0) {ui.checkBox_bmi->setChecked(true);}
			
		}
		if (strcmp(wartosc,"0.7.2")==1)
		{
			fscanf(plik,"%s%*s%s\n",nazwa,wartosc); // Przerwa midzy kieliszkami
			ui.spinBox_czas_kieliszki->setValue((int)strtof(wartosc,&endptr));
		}
		fclose(plik);
	}

}

void Form1::zapisz_konfiguracje()
{
#ifdef WIN32
	plik = fopen("promileqt.rc","w+");
#else
	strcpy(sciezka,katalog_domowy_plik(".promileqt.rc"));
	plik = fopen(sciezka,"w+");
#endif
	if (!plik)
	{
		printf("%s","Bd odczytu pliku");
	}
	else
	{
		fprintf(plik,"%s = %s\n","wersja",WERSJA);
		fprintf(plik,"%s = %c\n","plec",plec);
		fprintf(plik,"%s = %i\n","masa",ui.spinBox_waga->value());
		fprintf(plik,"%s = %i\n","wzrost",ui.spinBox_wzrost->value());
		fprintf(plik,"%s = %f\n","usuwanie_stale",ui.doubleSpinBox_prom_na_godz->value());
		fprintf(plik,"%s = %i\n","kraj",ui.comboBox_kraj->currentIndex());
		fprintf(plik,"%s = %f\n","smierc",ui.doubleSpinBox_dawka_smiertelna->value());
		fprintf(plik,"%s = %i\n","objetosc",ui.spinBox_ilosc->value());
		fprintf(plik,"%s = %f\n","zawartosc",ui.doubleSpinBox_zawartosc->value());
		fprintf(plik,"%s = %i\n","czcionka_programu_wielkosc",czcionka_programu.pointSize());
		fprintf(plik,"%s = %i\n","czcionka_wynikow_wielkosc",czcionka_wynikow.pointSize());
		fprintf(plik,"%s = %i\n","co_ile_minut_wynik",ui.spinBox_co_ile->value());
		fprintf(plik,"%s = %f\n","usuwanie_zmienne",ui.doubleSpinBox_maxg_na_godz->value());
		if (ui.radioButton_stala_szybkosc->isChecked())
		{
			fprintf(plik,"%s = %s\n","model_usuwania","staly");
		}
		else
		{
			fprintf(plik,"%s = %s\n","model_usuwania","zmienny");
		}
		fprintf(plik,"%s = %f\n","poczatek_picia",pierwszy);
		if (ui.checkBox_bmi->isChecked()) 
		{
		fprintf(plik,"%s = %c\n","uwzgledniac_bmi",'t');
		}
		else
		fprintf(plik,"%s = %c\n","uwzgledniac_bmi",'n');
		fprintf(plik,"%s = %i\n","czas_miedzy_kieliszkami",ui.spinBox_czas_kieliszki->value()); //przerwa miedzy kieliszkami
	}
	fclose(plik);
}

